<!DOCTYPE html>
<html lang="en">
<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">

    <!-- Optional theme -->
    <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
    <link rel="stylesheet" href="../static/fa/css/font-awesome.min.css">

    <script type="text/javascript">
	var room = 1;
function routes() {

    room++;



    var objTo = document.getElementById('routes')
    var divtest = document.createElement("div");
	divtest.setAttribute("class", "row form-group removeclass"+room);
	var rdiv = 'removeclass'+room;
    divtest.innerHTML = '<div class="col-sm-2"><div class="form-group"> <input type="text" class="form-control" id="servicePath" name="servicePath[]" value="" placeholder="Service Path" required></div></div><div class="col-sm-2"><div class="form-group"> <input type="text" class="form-control" id="path" name="path[]" value="" placeholder="Endpoint Path" required></div></div><div class="col-sm-3"><div class="form-group"> <input type="text" class="form-control" id="pathDesc" name="pathDesc[]" value="" placeholder="Endpoint Description" required></div></div><div class="col-sm-2"><div class="form-group"> <input type="text" class="form-control" id="method" name="Method[]" value="" placeholder="Method" required></div></div><div class="col-sm-3"><div class="form-group"><div class="input-group"> <select class="form-control" id="authRequired" name="authRequired[]" required><option value="">Authentication Required</option><option value="true">True</option><option value="false">False</option></select><div class="input-group-btn"> <button class="btn btn-danger" type="button" onclick="remove_routes('+ room +');"> <span class="fa fa-minus" aria-hidden="true"></span> </button></div></div></div></div><div class="clear"></div>';

    objTo.appendChild(divtest)
}

function onloadRoutes(servicePath, path, pathD, method, trueS, falseS) {

    room++;

    var objTo = document.getElementById('routes')
    var divtest = document.createElement("div");
	divtest.setAttribute("class", "row form-group removeclass"+room);
	var rdiv = 'removeclass'+room;
    divtest.innerHTML = `<div class="col-sm-2"><div class="form-group"> <input type="text" class="form-control" id="servicePath" name="servicePath[]" value="${servicePath}" placeholder="${servicePath}" required></div></div><div class="col-sm-2"><div class="form-group"> <input type="text" class="form-control" id="path" name="path[]" value="${path}" placeholder="${path}" required></div></div><div class="col-sm-3"><div class="form-group"> <input type="text" class="form-control" id="pathDesc" name="pathDesc[]" value="${pathD}" placeholder="${pathD}" required></div></div><div class="col-sm-2"><div class="form-group"> <input type="text" class="form-control" id="method" name="Method[]" value="${method}" placeholder="${method}" required></div></div><div class="col-sm-3"><div class="form-group"><div class="input-group"> <select class="form-control" id="authRequired" name="authRequired[]" required><option value="">Authentication Required</option><option value="true" ${trueS}>True</option><option value="false" ${falseS}>False</option></select><div class="input-group-btn"><button class="btn btn-danger" type="button" onclick="remove_routes(${room});"> <span class="fa fa-minus" aria-hidden="true"></span> </button></div></div></div></div><div class="clear"></div>`;

    objTo.appendChild(divtest)
}
   function remove_routes(rid) {
	   $('.removeclass'+rid).remove();
   }

</script>

    <title>{{title}}</title>
</head>
<body>
{% include 'navbar.html' %}
<br/>


{% with messages = get_flashed_messages(with_categories=True) %}
{% if messages %}
{% for cat, msg in messages %}

<div class="container">
    <div class="alert alert-warning alert-dismissible fade show" role="alert">
        <strong>{{ cat.capitalize() }}: </strong> {{ msg }}
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
</div>
{% endfor %}
{% endif %}
{% endwith %}


<br/>
<div class="container">
    <form method="POST" action="{{ url_for('views.update_serv') }}">
        <div class="form-group">
            <label for="apiName">API Name</label>
            <input type="text" class="form-control" id="apiName" placeholder="{{ records.NAME }}" value="{{ records.NAME }}" name="apiName" autofocus required>
        </div>
        <div class="form-group">
            <label for="apiDesc">API Description</label>
            <input type="text" class="form-control" id="apiDesc" placeholder="{{ records.DESC }}" value="{{ records.DESC }}" name="apiDesc" autofocus required>
        </div>

        <div class="form-group">
            <label for="apiServer">API Server URL</label>
            <input type="text" class="form-control" id="apiServer" placeholder="{{records.URL}}" value={{records.URL}} name="serverURL" autofocus required>
        </div>
        <div class="form-group">
            <label for="AuthCheckAPI">Authentication Check API</label>
            <input type="text" class="form-control" id="AuthCheckAPI" placeholder="{{records.AUTH_CHECK_API}}" value="{{records.AUTH_CHECK_API}}" name="AuthCheckAPI" autofocus>
        </div>
        <div class="form-group">
            <label for="apiSecret">Api Secret</label>
            <input type="text" class="form-control" id="apiSecret" placeholder="{{records.API_SECRET}}" value="{{records.API_SECRET}}" name="apiSecret" autofocus>
        </div>



        <div class="">
            <div class="font-weight-bold">Routes to Expose</div>





            <div id="routes">

            </div>
            {% for ep in records.ROUTES %}
                <script type="text/javascript">
                    {% set t='`selected`' if ep.authRequired == 'true' else ""|tojson %}
                    {% set f= '`selected`' if ep.authRequired == 'false' else ""|tojson %}
                    var path={{ ep.path|tojson }};
                    var servPath={{ ep.servicePath|tojson }};
                    var desc={{ ep.pathDesc|tojson }};
                    var method={{ ep.method|tojson }};
                    var t = {{t}};
                    var f = {{f}};

                    window.onloadRoutes(servPath, path, desc, method, t, f);
                </script>
            {% endfor %}
            <div class="input-group-btn">
                <button class="btn btn-success" type="button"  onclick="routes();"> Add New Endpoint </button>
            </div>


        </div>

        <div class="col-auto my-1">
            <button type="submit" class="btn btn-primary btn-lg" name="Edit" value="{{ records.NAME }}">Update</button>
        </div>
    </form>
</div>
<br/>



</body>
</html>
